# This file is a template, and might need editing before it works on your project.
# To contribute improvements to CI/CD templates, please follow the Development guide at:
# https://docs.gitlab.com/ee/development/cicd/templates.html
# This specific template is located at:
# https://gitlab.com/gitlab-org/gitlab/-/blob/master/lib/gitlab/ci/templates/Pages/Hugo.gitlab-ci.yml

---
# All available Hugo versions are listed here:
# https://gitlab.com/pages/hugo/container_registry
default:
  image: "${CI_TEMPLATE_REGISTRY_HOST}/pages/hugo:latest" # Default to Hugo in order to build the pages

variables:
  GIT_SUBMODULE_STRATEGY: recursive
  FF_NETWORK_PER_BUILD: 1 # Allow multiple container network communication
  TRIGGER_SCAN:
    value: "true"
    options:
      - "true"
      - "false"
    description: "Trigger a vulnerability scan on demand"

stages:
  - deploy
  - scan
  - check
  - pages

## Deploy stage:
# Will build and push the image to the repo's registery
##

deploy:
  services:
    - name: docker:dind
      alias: dind
  image: docker:20.10.16
  stage: deploy
  script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
    - docker pull $CI_REGISTRY_IMAGE:latest || true
    - docker build --tag $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA --tag $CI_REGISTRY_IMAGE:latest .
    - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA
    - docker push $CI_REGISTRY_IMAGE:latest

## Scan stage:
# Will scan the image using ZAP, build a report, and stop the pages process if a vulnerability is found
##

scan:
  services:
    - name: docker:dind
      alias: dind
  image: docker:24.0.6
  stage: scan
  script:
    - mkdir -p zap-reports
    - chmod 777 zap-reports
    - docker run -d -p 80:80 --name scantest $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA
    - sleep 5
    - IP_ADDRESS=$(docker inspect -f '{{range .NetworkSettings.Networks}}{{.IPAddress}}{{end}}' scantest)
    - docker run -v $(pwd)/zap-reports:/zap/wrk/:rw -t owasp/zap2docker-stable zap-baseline.py -t http://${IP_ADDRESS} -gen.conf -r report.html -J report.json || true
    - echo "Full report => https://sdv9972401.gitlab.io/-/ci_cd/partie-3/hugovelo-cicd-exercice-3/-/jobs/$CI_JOB_ID/artifacts/zap-reports/report.html"
  artifacts:
    paths:
      - zap-reports/report.html
      - zap-reports/report.json
  rules:
    - if: $TRIGGER_SCAN == 'true'

vulnerability:
  image: python:latest
  stage: check
  script:
    - python ./check.py ./zap-reports/report.json
  rules:
    - if: $TRIGGER_SCAN == 'true'
      when: on_success

## Pages stage:
# Will build the site and deploy it to GitLab Pages
##

pages_staging:
  stage: pages
  script:
    - git submodule add --force https://github.com/theNewDynamic/gohugo-theme-ananke.git velohugo/themes/ananke
    - cd velohugo && hugo --environment staging
  artifacts:
    paths:
      - velohugo/public_staging
  rules:
    - if: $CI_COMMIT_BRANCH == "staging"
  environment:
    name: staging
    url: 'https://sdv9972401.gitlab.io/-/ci_cd/partie-2/hugovelo-cicd-exercice-2/-/jobs/$CI_JOB_ID/artifacts/public_staging/index.html'

pages:
  stage: pages
  script:
    - git submodule add --force https://github.com/theNewDynamic/gohugo-theme-ananke.git velohugo/themes/ananke
    - cd velohugo && hugo --environment production
  artifacts:
    paths:
      - public
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
  environment:
    name: production
    url: 'https://sdv9972401.gitlab.io/ci_cd/partie-2/hugovelo-cicd-exercice-3'